grammar TreeAndLexerRules;

// tree is a reserved word in antrl3, a parser rule with that name is confusing antlr4

mytree   : treeLeaf | treeNode ;
treeLeaf : BEZ ; 
treeNode : BEZ '(' mytree (',' mytree)*  ')' ;

/*
 * Lexer Rules
 */

BEZ       : ([a-z] | [A-Z]) ([a-z] | [A-Z] | [0-9] | '_')* ;

NAT       : '0' | ([1-9] [0-9]*) ;

WHITESPACE: (' ' | '\t')        -> skip ;

NEWLINE   : ('\r'? '\n' | '\r') -> skip ;