﻿using Eingabeverwaltung.Metamodell;
using System.Collections.Generic;

namespace Ueberpruefung.CheckInduction
{
    /// <summary>
    /// checks error 35
    /// </summary>
    public class CheckIndPartEquationIsFixed : CheckIndPartEquationFixedVars
    {
        public CheckIndPartEquationIsFixed(Induction parent) :base(parent) { }

        /// <summary>
        /// checks using the should value and is value of fixed vars. Writes errors to contextErrorList <br></br>
        /// uses check35 from base class.
        /// </summary>
        /// <param name="shouldValueFixedVars"></param>
        /// <param name="isValueFixedVars"></param>
        /// <param name="contextErrorList"></param>
        /// <returns></returns>
        protected override bool check(List<Variable> shouldValueFixedVars, List<Variable> isValueFixedVars, List<Error> contextErrorList)
        {
            isValueFixedVars = new List<Variable>(isValueFixedVars); // copy list
            bool result = check35(shouldValueFixedVars,isValueFixedVars, out string err35Output);
            if (!result) contextErrorList.Add(new Error(35, err35Output));
            return result;
        }
    }
}
